<?php 
/**
 * Display a vertical loading bar with percent info, 
 * filled in natural order (down to up)
 * from 0 to 100% increase by step of 10%
 * with default colors
 * and with message line of progress bar filled
 * on different steps.
 * 
 * @version    $Id: progress12.php,v 1.2 2003/08/27 18:24:47 Farell Exp $
 * @author     Laurent Laville <pear@laurent-laville.org>
 * @package    HTML_Progress
 */

require_once ('HTML/Progress/BarVertical.php');

$p = new HTML_Page();
$p->setTitle("PEAR::HTML_Progress - Example 12");
$p->setMetaData("author", "Laurent Laville");


$bar = new HTML_Progress_Bar_Vertical('natural', $p);

$text = array(
    'size'    => 14, 
    'width'   => 60,
    'height'  => 30, 
    'color'   => 'white', 
    'background-color' => '#444444',
    'h-align' => 'left',
    'v-align' => 'bottom'
);
$bar->setText(true, $text);

$message = array(
    'width' => 100,
    'font'  => 'Arial, Helvetica', 
    'size'  => 10, 
    'color' => 'lightyellow', 
    'background-color' => '#444444',
    'h-align' => 'left',
    'v-align' => $_GET['align']
);
$bar->setMessageLine(true, $message);

$css = $bar->getStyle();
$css->setStyle('body', 'background-color', '#444444');
$css->setStyle('body', 'color', 'white');
$css->setStyle('body', 'font-family', 'Verdana, Arial');
$css->setStyle('a:link', 'color', 'yellow');
$css->setSameStyle('a:visited, a:active', 'a:link');
$css->setStyle('div.col1', 'float', 'left');
$css->setStyle('div.col1', 'width', '25%');
$css->setStyle('div.col2', 'margin-left', '30%');
$css->setStyle('div.col2', 'border', '3px solid silver');
$css->setStyle('div.col2', 'padding', '1em');
$css->setStyle('div.col2', 'height', '80%');

$p->addStyleDeclaration($css);
$p->addScriptDeclaration( $bar->getScript() );
$p->addBodyContent('<div class="col1">'.$bar->toHTML().'</div>');
$p->addBodyContent('<div class="col2">');
$p->addBodyContent('<h1>Example 12</h1>');
$p->addBodyContent('<p><i>Laurent Laville, August 2003</i></p>');

$note = <<< TEXT
<p>Different messages may be display during progress, see API <b>SetMessage</b> in action.</p>
TEXT;

$p->addBodyContent($note);
$p->addBodyContent('<p><a href="progress12.php?align=top">Top</a></p>');
$p->addBodyContent('<p><a href="progress12.php?align=bottom">Bottom (default)</a></p>');
$p->addBodyContent('</div>');
$p->display();


$bar->setMessage('running ...');

for ($i=0; $i<10; $i++) {
/*  You have to do something here  */
    $bar->display(10);
    if ($bar->getProgress() >= 50) {
        $bar->setMessage('half done');
    }
}
$bar->setMessage('done!');
$bar->display(100,"set");

echo '<p>&lt;&lt; <a href="index.html">Back documentation</a></p>';

?>